"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const TransactionDTO_1 = require("../dto/TransactionDTO");
class DBTransaction extends TransactionDTO_1.TransactionDTO {
    constructor(version, currency, locktime, hash, blockstamp, issuers, inputs, outputs, unlocks, signatures, comment, blockstampTime, written, removed, block_number, time) {
        super(version, currency, locktime, hash, blockstamp, blockstampTime, issuers, inputs, outputs, unlocks, signatures, comment);
        this.version = version;
        this.currency = currency;
        this.locktime = locktime;
        this.hash = hash;
        this.blockstamp = blockstamp;
        this.issuers = issuers;
        this.inputs = inputs;
        this.outputs = outputs;
        this.unlocks = unlocks;
        this.signatures = signatures;
        this.comment = comment;
        this.blockstampTime = blockstampTime;
        this.written = written;
        this.removed = removed;
        this.block_number = block_number;
        this.time = time;
    }
    static fromTransactionDTO(dto, blockstampTime, written, removed, block_number, block_medianTime) {
        return new DBTransaction(dto.version, dto.currency, dto.locktime, dto.hash, dto.blockstamp, dto.issuers, dto.inputs, dto.outputs, dto.unlocks, dto.signatures, dto.comment || "", blockstampTime, written, removed, block_number, block_medianTime);
    }
}
exports.DBTransaction = DBTransaction;
//# sourceMappingURL=DBTransaction.js.map