import { ConfDTO } from "../../../lib/dto/ConfDTO";
export interface UPnPBinding {
    remotehost: string;
    host: string;
    port: number;
}
export declare class WS2PUpnp {
    private logger;
    private conf;
    private currentConfig;
    private interval;
    private client;
    constructor(logger: any, conf: ConfDTO);
    checkUPnPisAvailable(): Promise<boolean>;
    getCurrentConfig(): UPnPBinding | null;
    getUpnpDescription(): string;
    /**
     * Always open the same port during an execution of Duniter.
     * @returns { host:string, port:number }
     */
    openPort(): Promise<{
        host: string;
        port: number;
    }>;
    startRegular(): Promise<{
        host: string;
        port: number;
        available: boolean;
    }>;
    stopRegular(): void;
    static getLocalIP(client: any): Promise<string>;
    static getRemoteIP(client: any): Promise<string>;
    private getAvailablePort(client);
    static getUPnPMappings(client: any): Promise<any>;
}
