import { TestingServer } from "./toolbox";
import { CertificationDTO } from "../../../app/lib/dto/CertificationDTO";
import { MembershipDTO } from "../../../app/lib/dto/MembershipDTO";
import { RevocationDTO } from "../../../app/lib/dto/RevocationDTO";
import { PeerDTO } from "../../../app/lib/dto/PeerDTO";
export interface TestInput {
    src: string;
    unlock: string;
}
export interface TestOutput {
    qty: number;
    base: number;
    lock: string;
}
export declare class TestUser {
    uid: string;
    private options;
    node: any;
    pub: string;
    sec: string;
    private createdIdentity;
    constructor(uid: string, options: any, node: any);
    private init(done);
    createIdentity(useRoot?: boolean, fromServer?: any): Promise<void>;
    submitIdentity(raw: string, fromServer: any): Promise<{}>;
    getIdentityRaw(): string;
    makeCert(user: TestUser, fromServer?: TestingServer, overrideProps?: any): Promise<CertificationDTO>;
    cert(user: TestUser, fromServer?: TestingServer, toServer?: TestingServer): Promise<void>;
    join(): Promise<void>;
    leave(): Promise<void>;
    makeRevocation(givenLookupIdty?: any, overrideProps?: any): Promise<RevocationDTO>;
    revoke(givenLookupIdty?: any): Promise<{}>;
    makeMembership(type: string, fromServer?: TestingServer, overrideProps?: any): Promise<MembershipDTO>;
    sendMembership(type: string): Promise<void>;
    send(amount: number, recipient: string, comment?: string): (done: (e?: any) => void) => Promise<void>;
    sendMoney(amount: number, recipient: TestUser, comment?: string): Promise<void>;
    sendTX(rawTX: string): Promise<any>;
    prepareUTX(previousTX: string, unlocks: string[], outputs: TestOutput[], opts: any): Promise<string>;
    prepareMTX(previousTX: string, user2: TestUser, unlocks: string[], outputs: TestOutput[], opts: any): Promise<string>;
    prepareITX(amount: number, recipient: TestUser | string, comment?: string): Promise<string>;
    private signed(raw, user2?);
    makeTX(inputs: TestInput[], outputs: TestOutput[], theOptions: any): string;
    prepareTX(inputs: TestInput[], outputs: TestOutput[], theOptions: any): string;
    makePeer(endpoints: string[], overrideProps: any): Promise<PeerDTO>;
    private post(uri, data, done?);
    private doPost(uri, data, toServer?);
    private getContacter(fromServer?);
    lookup(pubkey: string, fromServer?: TestingServer): Promise<any>;
    sendP(amount: number, userid: string, comment?: string): Promise<{}>;
}
